﻿package scripts
{
	import flash.events.*;
	import flash.events.EventDispatcher;
	import scripts.BitmapToAsciiConverter;
	import scripts.Image;
	
	//Kép betöltésének és karakterekké konvertálásának osztálya
	public class AsciiArtBuilder extends EventDispatcher
	{
		public var image:Image;
		public var asciiArtText:String = "";

		public function AsciiArtBuilder()
		{
		}
		
		//Kép sikeres betöltése esetén konvertálás karakterekké
		private function imageCompleteHandler(event:Event):void
		{
			//konvertáló objektum létrehozása a betöltött képpel
			var imageConverter:BitmapToAsciiConverter = new BitmapToAsciiConverter(image);
			//A konverter segítségével létrehozzuk a karakterláncot, és megjelenítjük a megfelelő helyen
			this.asciiArtText = imageConverter.parseBitmapData();
			
			var readyEvent:Event = new Event("ready");
			//Eseményt bocsát ki, hogy a konvertálás megtörtént
			dispatchEvent(readyEvent);
		}
		
		//Kép betöltése
		public function convert(imagePath:String):void
		{
			//új kép objektum a megadott elérési útvonal alapján
			image = new Image(imagePath);
			//esemény, ha sikeresen betöltődött
			image.addEventListener(Event.COMPLETE, imageCompleteHandler);
			//esemény, ha hiba történt
			image.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
			//kép betöltése
			image.load();
		}
		
		//Kép betöltésével kapcsolatos hiba esemény kezelése
		private function ioErrorHandler(event:Event):void
		{
			dispatchEvent(event);
		}
	}
}