﻿package scripts
{
	import flash.display.BitmapData;

	//Karakterekké konvertálás osztálya
	public class BitmapToAsciiConverter
	{
		//felbontás
		private static const _resolution:Number = .025;
		//képet tároló objektum
		private var _data:BitmapData;
		//karakterek sorozata, amiket majd a különböző színértékeknek feleltetünk meg
		private static const palette:String = "@#$%&8BMW*mwqpdbkhaoQ0OZXYUJCLtfjzxnuvcr[]{}1()|/?Il!i><+_~-;,. ";

		//Képadatok betöltése
		public function BitmapToAsciiConverter(image:Image)
		{
			//képobjektum adatainak kinyerése
			this._data = image.getBitmapData();
		}

		//Kép feldolgozása
		public function parseBitmapData():String
		{
			var rgbVal:uint;
			var redVal:uint;
			var greenVal:uint;
			var blueVal:uint;
			var grayVal:uint;
			var index:uint;
			
			//pixelek száma vízszintesen és függőlehesen, a kép méretei és megadott felbontás alapján
			var verticalResolution:uint = Math.floor(_data.height * _resolution); 
			var horizontalResolution:uint = Math.floor(_data.width * _resolution * 0.45);
			
			//változó a karakterlánc tárolására
			var result:String = "";
			
			//ciklus, ami végigiterál a kép pixelein
			for (var y:uint = 0; y < _data.height; y += verticalResolution)
			{
				for (var x:uint = 0; x < _data.width; x += horizontalResolution)
				{
					//pixel színének kinyerése
					rgbVal = _data.getPixel(x, y);
					//különböző színértékek kinyerése az RGB értékből
					redVal = (rgbVal & 0xFF0000) >> 16;
					greenVal = (rgbVal & 0x00FF00) >> 8;
					blueVal = rgbVal & 0x0000FF;

					//Színes sürkeárnyalatúvá konvertálása:
					//(Y = gray): Y = 0.3*R + 0.59*G + 0.11*B
					grayVal = Math.floor(0.3 * redVal + 0.59 * greenVal + 0.11 * blueVal);
					
					//árnyalat (vagyis eredetileg szín) megfeleltetése egy karakterrel
					index = Math.floor(grayVal / 4);
					result += palette.charAt(index);
				}
				result += "\n";
			}
			return result;
		}
	}
}