﻿package scripts
{
	import flash.events.*;
	import flash.display.Loader;
	import flash.net.URLRequest;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.events.EventDispatcher;
	import scripts.AsciiArtBuilder;

	//A kép betöltésére szolgáló osztály
	public class Image extends EventDispatcher
	{
		private var _loader:Loader;
		public var path:String;

		//Kép objektumának létrehozása
		public function Image(imagePath:String)
		{
			//kép elérési útvonala
			this.path = imagePath;
			//fájlok betöltésére szolgáló objektum
			_loader = new Loader();
			//konvertálás sikerességét jelző esemény
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler);
			//hibát jelző esemény
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,ioErrorHandler);
		}

		//Képadatok betöltése
 		public function getBitmapData():BitmapData
		{
			//képadatok visszaadása a betöltő objektumból
			return Bitmap(_loader.content).bitmapData;
		}
		
		//Kép betöltése
		public function load():void
		{
			var request:URLRequest = new URLRequest(path);
			//kép betöltése
			_loader.load(request);
		}	
 		
		//Esemény kiváltása sikeres betöltéskor
 		private function completeHandler(event:Event):void
		{
			dispatchEvent(event);
		}	
		
		//Esemény kiváltása hiba esetén
		private function ioErrorHandler(event:Event):void
		{
			dispatchEvent(event);
		}
	}
}